package com.gic.enterprise.service;

import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.auth.dto.UserDTO;
import com.gic.enterprise.dto.EnterpriseDTO;
import com.gic.enterprise.dto.EnterpriseInitDTO;
import com.gic.enterprise.dto.EnterpriseListDTO;

import java.util.List;

/**
 * @author guojx
 * @date 2019/7/16 4:12 PM
 */
public interface EnterpriseApiService {

    /**
     * 新建商户
     * @param enterpriseDTO
     * @return 主键ID
     */
    ServiceResponse<Integer> saveEnterprise(EnterpriseDTO enterpriseDTO);

    /**
     * 新建商户
     * @param enterpriseDTO
     * @param userDTO
     * @return 主键ID
     */
    ServiceResponse<Integer> saveEnterprise(EnterpriseDTO enterpriseDTO, UserDTO userDTO);


    /**
     * 编辑保存
     * @param enterpriseDTO
     * @return
     */
    ServiceResponse<Integer> editEnterprise(EnterpriseDTO enterpriseDTO);

    /**
     * 根据主键获取数据
     * @param enterpriseId
     * @return
     */
    ServiceResponse<EnterpriseDTO> getEnterpriseById(Integer enterpriseId);

    /**
     * 停用
     * @param enterpriseId
     * @return
     */
    ServiceResponse disableEnterprise(Integer enterpriseId);

    /**
     * 启用
     * @param enterpriseId
     * @return
     */
    ServiceResponse enableEnterprise(Integer enterpriseId);

    ServiceResponse<Page<EnterpriseListDTO>> listEnterprise(String search, Integer serviceVersion,
                                                                Integer status, String orderBy,
                                                                Integer pageNum, Integer pageSize);

    /**
     * 初始化商户
     * @param enterpriseId
     * @return
     */
    ServiceResponse initEnterprise(Integer enterpriseId);
}
