package com.gic.enterprise.service.impl;

import com.gic.commons.util.GlobalInfo;
import com.gic.enterprise.dao.mapper.TabPlatformBrandRefMapper;
import com.gic.enterprise.dto.PlatformBrandRefDTO;
import com.gic.enterprise.entity.TabPlatformBrandRef;
import com.gic.enterprise.service.PlatformBrandRefService;
import com.github.pagehelper.Page;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.*;

public class PlatformBrandRefServiceImpl implements PlatformBrandRefService {

    @Autowired
    private TabPlatformBrandRefMapper tabPlatformBrandRefMapper;

    @Override
    public Integer countByPlatformBrandId(Integer platformBrandId) {
        return tabPlatformBrandRefMapper.countByPlatformBrandId(platformBrandId);
    }

    @Override
    public Map<Integer, Integer> countByPlatformBrandIds(List<Integer> platformBrandIdList) {
        if (CollectionUtils.isNotEmpty(platformBrandIdList)) {
            //
            Map<Integer, Integer> map = new HashMap<>();
            List<Map<String, Integer>> list = tabPlatformBrandRefMapper.countByPlatformBrandIds(platformBrandIdList);
            for (Map<String, Integer> integerIntegerMap : list) {
                map.put(integerIntegerMap.get("platformBrandId"), integerIntegerMap.get("brandCount"));
            }
            return map;
        } else {
            return Collections.emptyMap();
        }
    }

    @Override
    public Integer save(PlatformBrandRefDTO platformBrandRefDTO) {
        TabPlatformBrandRef platformBrandRef = new TabPlatformBrandRef();
        platformBrandRef.setPlatformBrandId(platformBrandRefDTO.getPlatformBrandId());
        platformBrandRef.setEnterpriseId(platformBrandRefDTO.getEnterpriseId());
        platformBrandRef.setEnterpriseBrandId(platformBrandRefDTO.getEnterpriseBrandId());
        platformBrandRef.setEnterpriseBrandName(platformBrandRefDTO.getEnterpriseBrandName());
        platformBrandRef.setEnterpriseBrandCode(platformBrandRefDTO.getEnterpriseBrandCode());
        platformBrandRef.setCreateTime(new Date());
        platformBrandRef.setStatus(GlobalInfo.DATA_STATUS_NORMAL);
        tabPlatformBrandRefMapper.insertSelective(platformBrandRef);
        return platformBrandRef.getPlatformBrandId();
    }

    @Override
    public Integer delRef(Integer enterpriseId, Integer enterpriseBrandId) {
        return tabPlatformBrandRefMapper.delRef(enterpriseId, enterpriseBrandId);
    }

    @Override
    public Page<TabPlatformBrandRef> listByPlatformBrandRef(String brandName) {
        TabPlatformBrandRef brandRef = new TabPlatformBrandRef();
        brandRef.setEnterpriseBrandName(brandName);
        return tabPlatformBrandRefMapper.listByPlatformBrandRef(brandRef);
    }

    @Override
    public Integer updateRef(Integer fromBrandId, Integer toBrandId) {
        return tabPlatformBrandRefMapper.updateRef(fromBrandId, toBrandId);
    }
}
